module abstract_imag_mod
  !! This module contains the abstract type from where
  !! xcorrelation and energy imaging conditions extend
  use bwd_propagation_mod, only : src_rcv_prop_bwd
  implicit none
  private
  public :: abst_imag

  type, abstract :: abst_imag
  contains
    procedure(xcorrIC_interface), deferred :: xcorrIC
    procedure(energyIC_interface), deferred :: energyIC
  end type

  abstract interface
    subroutine xcorrIC_interface(this,bwd)
      import abst_imag,src_rcv_prop_bwd
      class(abst_imag), intent(inout) :: this
      type(src_rcv_prop_bwd), intent(in) :: bwd
    end subroutine

    subroutine energyIC_interface(this,bwd)
      import abst_imag,src_rcv_prop_bwd
      class(abst_imag), intent(inout) :: this
      type(src_rcv_prop_bwd), intent(inout) :: bwd
    end subroutine
  end interface
end module
