!! This module performs the application of the Hessian
!! Adapted from an Ali Almomin's code to modern Fortran
module H_mod
  use sep
  use lint2_mod
  use declare_variables_mod
  use read_mod, only : read_
  use write_mod, only : write_
  use fwd_propagation_mod, only : src_prop_fwd
  use bwd_propagation_mod, only : src_rcv_prop_bwd
  use rtm_mod, only : rtm_image
  use base_trismt_mod
  use skull_mod
 
  implicit none
  integer, private :: allocation_status, dummy
  integer, private :: j, jz, jx, jzc, jxc, jlagz, jlagx
  integer, private :: incPSFz, incPSFx, first_cdp, last_cdp
  integer, private :: nz, nx, nlagz, nlagx, n3, n4
  integer, private :: nzc, nxc
  real, private :: o1, o2, d1, d2, x, z
  real, pointer, private :: xz(:,:)
  real, dimension(:),       allocatable, private :: d
  real, dimension(:,:),     allocatable, private :: temp, m, diff
  real, dimension(:,:,:,:), allocatable, private :: Hgn
!  logical, parameter, private ::  F=.false., T=.true.
  type(src_prop_fwd), private     :: fwd 
  type(src_rcv_prop_bwd), private :: bwd 
  type(write_), private       :: outp
  type(rtm_image), private    :: image

  interface
    pure module subroutine H_init(par,diag,diagH)
      type(read_), intent(in)  :: par
      logical, intent(in) :: diag
      real, optional, intent(out) :: diagH(:,:)
    end subroutine
  
    impure module function H_op(adj, add, model, data_) result(stat)
      integer               :: stat 
      logical, intent(in)   :: adj, add 
      real, dimension(:)  :: model, data_
    end function
  
    impure module subroutine H_op2(adj, add, model, data_)
      logical, intent(in) :: adj, add
      real, dimension(nz,nx)  :: model, data_
    end subroutine
  end interface

end module
