module born_mod
  !! This module implements conventional correlation imaging conditions and
  !! energy imaging conditions, and build the migrated images
  use sep
  use declare_variables_mod, only : use_taper
  use read_mod, only : read_
  use fwd_propagation_mod, only : src_prop_fwd
!  use omp_lib
  use vshot_mod, only : vshot_foo
  use rshot_mod, only : rshot_foo
  use taper_mod
  use skull_mod
  use assertions
  implicit none
  private
  public :: born_foo

  integer :: dummy, allocation_status
  integer :: k, jt, jtCoarse, jx, jz, jgx, zshift, x1, x2, z1, z2
  integer, parameter :: jtsnap=10 
  real :: fx, jfx, src_scl1, src_scl2
  real, allocatable, dimension(:,:) :: scat_scl
  real, allocatable, dimension(:)   :: owt
  real, parameter :: pi = 4.*atan(1.) ! The Order of Chaos (Darren Aronofsky, 1998)
  logical, parameter :: T=.true., F=.false.
  type(src_prop_fwd), allocatable :: scat

  type born_foo
    !! This class has and numerators and denominators to create the migrated images 
    real, dimension(:,:), allocatable :: dsynt, reflshot, resd
  contains
    procedure :: born
    procedure :: born_init
  end type

  interface
    pure module subroutine born(this,par,fwd,vel,ref,jsources,temp)
      !! I apply the born modeling procedure here
      implicit none
      class(born_foo), intent(inout) :: this
      type(src_prop_fwd),     intent(inout) :: fwd 
      type(read_), intent(inout) :: par
      type(vshot_foo), intent(inout) :: vel
      type(rshot_foo), intent(inout) :: ref
      integer, intent(in) :: jsources
      real, optional, intent(in) :: temp(:,:)
    end subroutine

    pure module subroutine born_init(this,par,fwd,sx,gx)
      !! Here the scalar variables are initialized
      implicit none
      class(born_foo), intent(inout) :: this
      class(src_prop_fwd), intent(inout) :: fwd
      type(read_), intent(in) :: par
      real, dimension(:), intent(in) :: sx, gx
    end subroutine
  end interface
end module
