module grad_mod
  use lap_c_mod
  use interp1d_mod
  use skull_mod
  implicit none

  integer :: allocation_status
  integer :: jgx, jx, jz, jpol, jj, jd, jm, jaux
  real, dimension(:,:,:), allocatable :: dpxz, drxz

  real :: b1x, b2x, b3x, b4x, b5x, b6x, b1z, b2z, b3z, b4z, b5z, b6z
  real :: idx, idz, dp_xx, dr_zz
  real, dimension(:),     allocatable :: pauxgrad
  real, target,  dimension(:), allocatable:: pcur, pxcur, pzcur, rzcur
  interface
    pure module subroutine grad_init(fwd)
      !! This procedure initializes first order derivative arrays
      implicit none 
      type(src_prop_fwd), intent(in) :: fwd
    end subroutine
  

    pure module subroutine grad(bwd)
      !! This procedure calculates spatial first derivatives of wavefields
      implicit none
      type(src_prop_bwd), intent(inout) :: bwd
    end subroutine
  end interface
end module
