module taper_mod
  !! This module contains a taper that is used in the receiver wavefield
  !! for tapering boundaries conditions. It works because such field is
  !! not reversible
  use skull_mod
  use read_mod, only : read_
  implicit none
  integer, private         :: allocation_status
  integer, private         :: jx, jz, jj
  real, private, parameter :: pi=4.*atan(1.)
  real, private            :: dist
  real, private, pointer   :: zxtaper(:),ctaper(:,:)
  type(read_), private, allocatable :: par

  interface
    pure module subroutine taper_init(par_in,use_taper)
      !! This subroutine initializes the paramters
      implicit none
      type(read_), intent(in) :: par_in
      logical, intent(out) :: use_taper
    end subroutine

    pure module subroutine taperings(prev,cur,next)
      !! This subroutine applies the taper to the three wavefields components
      implicit none
      real, dimension(:,:), intent(inout) :: prev, cur, next
    end subroutine
  end interface
end module
