module vshot_mod
  !! This module contains the procedure to create velocity within the shot
  !! frame, adding aperture and random boundary conditions
  use skull_mod
  use read_mod, only : read_
  use fwd_propagation_mod, only : src_prop_fwd
  implicit none
  private
  public :: vshot_foo 
 
  integer :: allocation_status 
  integer :: jx, jz, jgx, k, shftx, shftz
  integer :: values(1:8) 
  integer, dimension(:), allocatable :: seed
  
  real :: rand1, rand2, fact, damp1, damp2, frac 
  real :: V_min, V_max, Vtest, distMax, distMaxU 
  real, parameter :: pi = 4.*atan(1.) ! The Order of Chaos (Darren Aronofsky, 1998)
  real, dimension(:),allocatable :: distXL, distXR, distZU, distZD, dist, distU

  type vshot_foo
  contains
    procedure, nopass :: vshot_init
    procedure, nopass :: vshot
  end type

  interface 
    pure module subroutine vshot_init(par)
      !! This subroutine enters the values needed for velocity computations
      implicit none
      type(read_), intent(in) :: par
    end subroutine

    pure module subroutine vshot(par,V_shot,sgx,rand) !,anis)
      !! This subroutine prepares the velocities and anisotropies by shot gather
      implicit none
!      class(vshot_foo), intent(inout) :: this
!      type(src_prop_fwd),  intent(inout) :: fwd
      type(read_), intent(in) :: par
      real,  intent(in)  :: sgx(:)
      real,  intent(out)  :: V_shot(:,:)
      logical, intent(in) :: rand
    end subroutine
  end interface
end module
