module wemva_op_mod
  use read_mod, only : read_
  use wemva_mod, only : wemva_foo
  use src_rcv_interp_mod
  use vshot_mod, only : vshot_foo
  use rshot_mod, only : rshot_foo
  use fwd_propagation_mod, only : src_prop_fwd
  use bwd_propagation_mod, only : src_rcv_prop_bwd
  use taper_mod
  implicit none

  integer, private :: nt, nkz, nkgx, jsources 
  real, private, allocatable  :: temp(:,:)
  type(wemva_foo), private, allocatable :: wemva
  type(read_),       private, allocatable :: par
  type(vshot_foo),   private, allocatable :: vel
  type(rshot_foo),   private, allocatable :: ref
  type(src_prop_fwd), private, allocatable :: fwd
  type(src_rcv_prop_bwd), private, allocatable :: bwd

  interface
    pure module subroutine wemva_op_init1(par_in,wemva_in)
      class(read_),       intent(in) :: par_in 
      class(wemva_foo), intent(in) :: wemva_in
    end subroutine

    pure module subroutine wemva_op_init2(rcv,vel_in,ref_in,fwd_in,bwd_in,jsources_in)
      real, intent(in) :: rcv(:,:)
      class(vshot_foo), intent(in) :: vel_in
      class(rshot_foo), intent(in) :: ref_in
      class(src_prop_fwd), intent(in) :: fwd_in
      class(src_rcv_prop_bwd), intent(in) :: bwd_in
      integer, intent(in) :: jsources_in
    end subroutine

    impure module function wemva_op(adj,add,model,data_) result(stat)
      integer             :: stat
      real, dimension(:)  :: model, data_
      logical, intent(in) :: adj, add
    end function

    impure module subroutine wemva_op2(adj,add,model,data_)
      real, dimension(nkz,nkgx) :: model
      real, dimension(nkz,nkgx) :: data_
      logical, intent(in) :: adj, add
    end subroutine

    pure module subroutine wemva_op_deallocate()
    end subroutine
    
  end interface

end module
